      program synch_k
      implicit none
!  FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer    ierr, nproc, myid, ik, tag, i, d
      integer sbuf, rbuf, ict, nc
      real*8 t1,t2, tbmax
!  initialize MPI, get nproc (# of procs) and myid (local proc. id)
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      call MPI_BARRIER( MPI_COMM_WORLD, ierr )


      t1 = MPI_WTIME()  
      t1 = MPI_WTIME()  

! Example implementation of a barrier (cascade access):

      sbuf = 1
      tag = 1
      d = nproc/2
      nc = 1000  
      do ict = 1 , nc
      do i = 1 , nproc
         if (myid.lt.d) then
            call MPI_RECV( rbuf, 1, MPI_INTEGER, myid+d, tag,
     :                 MPI_COMM_WORLD,MPI_STATUS_IGNORE,ierr )
         else if (myid.lt.2*d) then
            call MPI_SEND( sbuf, 1, MPI_INTEGER, myid-d, tag,
     :                     MPI_COMM_WORLD, ierr )
         end if
         if (d.eq.1) exit
         d = d/2
      end do
      do i = 1 , nproc
         if (myid.lt.d) then
            call MPI_SEND( sbuf, 1, MPI_INTEGER, myid+d, tag,
     :                     MPI_COMM_WORLD, ierr )
         else if (myid.lt.2*d) then
            call MPI_RECV( rbuf, 1, MPI_INTEGER, myid-d, tag,
     :                 MPI_COMM_WORLD,MPI_STATUS_IGNORE,ierr )
         end if
         if (d.eq.nproc/2) exit
         d = d*2
      end do

      end do
      t2 = MPI_WTIME() -t1
      write(6,*) myid,t1,t2
      call MPI_REDUCE( t2, tbmax, 1, MPI_DOUBLE_PRECISION,
     :                 MPI_MAX, 0, MPI_COMM_WORLD, ierr )
      if (myid.eq.0) then
      write(6,111) tbmax/nc , tbmax/nc*2600.0e+6
 111  format("MPI_BARRIER takes ",e10.2,"sec , i.e.",
     :        f8.0," cycles of 2.6e-9 sec")
      end if

      call MPI_FINALIZE( ierr )

      stop
      end



 
