      program barrier_use
      implicit none
      include 'mpif.h'

      real*8       ts, ti, timax, tf, tfmin
      integer      com, nproc, myid, ierr

      com = MPI_COMM_WORLD
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )
      if (myid.eq.0) then
         write(6,*)'taskid    before barrier    after barrier'
      end if
      ts = MPI_WTIME()
      call sleep(myid)
      ti = MPI_WTIME()-ts
      call MPI_BARRIER( com, ierr )
      tf = MPI_WTIME()-ts
      call MPI_ALLREDUCE(ti,timax,1,MPI_DOUBLE_PRECISION,MPI_MAX,
     :                   com,ierr)
      call MPI_ALLREDUCE(tf,tfmin,1,MPI_DOUBLE_PRECISION,MPI_MIN,
     :                   com,ierr)
      write(6,10) myid,ti,tf
 10   format(i4,'>>',2f16.8)
      if (myid.eq.0) call sleep(1)
      if (myid.eq.0) write(6,111) tfmin-timax
 111  format("time between last process before BARRIER and ",
     :       "first process after BARRIER :",/e10.2) 
     
      call MPI_FINALIZE( ierr )

      stop
      end













