      program p2p_vector
      implicit none
!  FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer    ierr, nproc, myid,
     :           i, nsend, nrecv, startsend, startrecv
      double precision vec(10)

!  initialize MPI, get nproc (# of procs) and myid (local proc. id)
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )

      do i = 1 , 10
         vec(i) = myid*i 
      end do
      write(6,111)myid,vec
 111  format(i3,'>> initial:    vec=',10f3.0)
           
      if (myid.eq.1) then
         startsend = 5; nsend = 3

         call MPI_SEND( vec(startsend), nsend, MPI_DOUBLE_PRECISION, 0, 
     :                  11, MPI_COMM_WORLD, ierr )
         write(6,*)'send error: ',ierr
      end if
      
      if (myid.eq.0) then
         startrecv = 2; nrecv = 3
         call MPI_RECV(vec(startrecv), nrecv, MPI_DOUBLE_PRECISION, 
     :                 MPI_ANY_SOURCE, MPI_ANY_TAG, 
     :                 MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr)
         write(6,113)myid,vec
 113     format(i3,'>> after revc: vec=',10f3.0)
         write(6,*)'recv error: ',ierr
      end if

      call MPI_FINALIZE( ierr )

      stop
      end



 
