      subroutine dist_index( n, firstind )
c     ===============================
c  all variables should be explicitely declared !
      implicit none 
c
      integer           n, firstind(0:*)
c
c  +-------------+----------------+------------------------------------+
c  |  parameter  |  input/output  |  description                       |
c  +-------------+----------------+------------------------------------+
c  |  n          |  input         |  indexrange to be distributed      |
c  |  firstind   |  output        |  vector, firstind(ip) contains     |
c  |             |                |  first global index on proc ip     |
c  +-------------+----------------+------------------------------------+
c  |                                                                   |
c  |  Purpose of this subroutine is to calculate the value of the first|
c  |  global index for each processor an to store these values into    |
c  |  integer vector firtstind                                         |
c  |                                                                   |
c  +-------------------------------------------------------------------+
c  |  ruler                                                            |
c  |5 7 10   15   20   25   30   35   40   45   50   55   60   65   70 | 
c  ++-+--+----+----+----+----+----+----+----+----+----+----+----+----+-+
c
c  FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
c  local variables
      integer           ierr, nproc, myid
      integer           nl, ip

      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      
      nl = (n+nproc-1)  / nproc
      firstind( 0 ) = 0
      do ip = 1 , nproc
         firstind(ip) = min(firstind(ip-1)+nl,n)
      end do
      return
      end
