c===================================================================
c      Waermeleitungsgleichung
c      Einprozessorprogramm 
c===================================================================
      program waermeleitung
      implicit none
      include 'mpif.h'
      integer      nmax, nmax2 
      parameter  ( nmax = 10000, nmax2 = nmax+2 )
      real*8       a(nmax2*nmax2), u(nmax2*nmax2)
      integer      n, nt, i, nop, nsample, is, aus, ierr
      real*8       r, t1, t2, speed, tav

c------------ 1. Parametereingabe ----------------
      call MPI_INIT( ierr )

         read(5,*) nt
         read(5,*) n
         read(5,*) r
         write(6,*) n,nt,r

      
      if (r.gt.0.25) then
         write(6,*)
     :'Warnung: r =',r,' ! Stabilitaet nur fuer r < 0.25 !' 
      end if

      if (n*n.gt.nmax**2) then
         write(6,*)
     :'Speicherplatz fuer Gittergroesse nicht ausreichend:'
         write(6,*)
     :      'nmax =',nmax,' n =',n
         stop
      end if

c------------ 2. Initialisierung der Anfangswerte u. Quellen -------
      call initialisierung ( n, n , a )
      call initialisierung ( n, n , u )

c------------ 3. Zeitschritte zur Temperaturfeldberechnung ---------
      t1 =  MPI_WTIME()
      do i = 1,nt
         call zeitschritt ( r, n, n, a, u )
         call zeitschritt ( r, n, n, u, a )
      end do
      t2 =  MPI_WTIME() - t1
      call temp( n, n, a, tav)
c------------ 4. Resultatausgabe - ---------------------------------
      call ausgabe_a ( n, n, a )
      write(6,'("-----------------------------")')
      write(6,'("  system size : ",i4," x ",i4)')n,n
      write(6,'("  after ",i4," timesteps :")') nt
      tav = tav/real(n)**2
      write(6,'("  average temperature :", f10.5)') tav
      write(6,'("  run time : ", f8.4)') t2
      nop = 6*n*n
      speed = 1.e-6*nop*2*nt/t2
      write(6,'("  run speed [Mflop/s] :",f8.2)') speed



      call MPI_FINALIZE( ierr )
      stop
      end

   






