      double precision function farmer(idle,n,ndom)
      use mpi
      implicit none

      integer idle, ipfa, nproc, n, ndom
      integer comm, ierr, iw, ipw, tag_fa, tag_wo, tag_cl
      double precision pia, pial, t
      tag_fa = 0; tag_wo = 1; tag_cl = 2
      comm = MPI_COMM_WORLD
      call MPI_COMM_SIZE( comm, nproc, ierr )
      call MPI_COMM_RANK( comm, ipfa, ierr )

! send ndom workpices to workers
      do iw = ndom , 1, -1
         t = MPI_WTIME()
         call MPI_RECV(ipw, 1, MPI_INTEGER,MPI_ANY_SOURCE,
     :                      tag_wo, comm, MPI_STATUS_IGNORE, ierr )
         t = MPI_WTIME()-t
!         write(6,*) iw, ipw, t
         call MPI_SEND(iw, 1, MPI_INTEGER, ipw, tag_fa, comm, ierr)
      end do

! stop  workers
      do ipw = 0 , nproc-1
         if (ipw.eq.ipfa.and.idle.eq.0) cycle
         call MPI_SEND(0,1,MPI_INTEGER,ipw, tag_fa, comm, ierr)
      end do
      pia = 0.d0

! collect work from workers
      do ipw = 0 , nproc-1
         if (ipw.eq.ipfa.and.idle.eq.0) cycle
         call MPI_RECV(pial, 1, MPI_DOUBLE_PRECISION, ipw,
     :                 tag_cl, comm, MPI_STATUS_IGNORE, ierr )
         pia = pia + pial
      end do
      farmer = pia
      return
      end


      subroutine worker(ipfa,n,ndom)
      use mpi
      implicit none

      integer ipfa, ipwo, nproc, n, ndom
      integer comm, ierr, i, iw, ipw, nl, tag_fa, tag_wo, tag_cl
      double precision numint, f, hi, lo, delt, width, pia, t
      tag_fa = 0; tag_wo = 1; tag_cl = 2
      comm = MPI_COMM_WORLD
      call MPI_COMM_SIZE( comm, nproc, ierr )
      call MPI_COMM_RANK( comm, ipwo, ierr )
      t = MPI_Wtime()
      width = 1.d0/ndom
      call MPI_SEND(ipwo, 1, MPI_INTEGER, ipfa, tag_wo, comm, ierr)
      pia = 0.d0
      do i = 1 ,  ndom+2
         call MPI_RECV(iw, 1, MPI_INTEGER,ipfa,
     :                      tag_fa, comm, MPI_STATUS_IGNORE, ierr )
         if (iw.lt.1) exit
         call work(iw, n, ndom, pia)
!         lo = 1.d0 - iw*width
!         hi = lo + width
!         nl = n * (f(lo) - f(hi))+1
!         delt = (hi-lo)/nl
!         pia = numint(lo,delt,nl,pia)
         call MPI_SEND(ipwo, 1, MPI_INTEGER, ipfa, tag_wo, comm, ierr)
      end do
      t = MPI_Wtime()-t
      print * ,' process ',ipwo,':',i-1,'  domains in',t,' sec'
      call MPI_SEND(pia, 1, MPI_DOUBLE_PRECISION, ipfa,
     :               tag_cl, comm, ierr )
      return
      end 

      subroutine work(iw, n, ndom, pia)
      implicit none
      integer iw, ndom, n, nl
      double precision numint, f, hi, lo, delt, width, pia

      width = 1.d0/ndom
      hi = iw*width
      lo = hi - width
      nl = n * (f(lo) - f(hi))+1
      delt = (hi-lo)/nl
      pia = numint(lo,delt,nl,pia)

      return
      end

